/*->c.fsx */

#include <stdafx.h>
#include "windows.h"
#include "shellapi.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include "os.h"
#include "oserr.h"


#include "err.h"
#include "bits.h"

#include "deb.h"
#include "etc.h"

#include "fsx.h"










os_error * fs_open(TCHAR * name,int mode,fshandle * fh)
{
 os_error * err;
 DWORD      createmode;
 DWORD      accessmode;
 HANDLE     handle;
 int        type;

 if(mode=='r')
 {
  createmode=OPEN_EXISTING;
  accessmode=GENERIC_READ;
 }
 else
 if(mode=='u')
 {
  createmode=OPEN_ALWAYS;
  accessmode=GENERIC_READ|GENERIC_WRITE;
 }
 else
 {
  accessmode=GENERIC_READ|GENERIC_WRITE;
  fs_exists2(name,&type);
  if(type==1) createmode=TRUNCATE_EXISTING;
  else
  if(type==0) createmode=CREATE_NEW;
  else
  {
   // error
   createmode=CREATE_NEW;
  }
 }


 err=XCreateFile(name,accessmode,FILE_SHARE_READ,NULL,createmode,FILE_ATTRIBUTE_NORMAL,NULL,&handle);
 if(err) *fh=0;
 else    *fh=(fshandle)handle;

 return(err);
}



os_error * fs_close(fshandle fh,os_error * ep)
{
 os_error * err;

 err=XCloseHandle((HANDLE)fh);

 if(!ep) return(err);
 else    return(ep);
}



os_error * fs_seek(fshandle fh,int posn)
{
 DWORD result;
 return(XSetFilePointer((HANDLE)fh,posn,NULL,FILE_BEGIN,&result));
}

os_error * fs_readn(fshandle fh,void * b,int n,int * read)
{
 os_error * err;


 err=XReadFile((HANDLE)fh,b,n,(unsigned long*)read,NULL);

 return(err);
}

os_error * fs_writen(fshandle fh,void * b,int n,int * write)
{
 return(XWriteFile((HANDLE)fh,b,n,(unsigned long*)write,NULL));
}




os_error * fs_write(fshandle fh,void * b,int n)
{
 os_error      * err;
 unsigned long   written;

 err=NULL;

 while(n)
 {
  err=XWriteFile((HANDLE)fh,b,n,&written,NULL);
  if(err) break;
  n-=written;
  b=(((char*)b)+written);

  if(!err && !written)
  {
   err=geterror(EWR);
   break;
  }
 }
 return(err);
}







/* returns 0 ==does not exist  1==file 2==dir */

os_error * fs_exists2(TCHAR * name,int * type)
{
 os_error   * err;
 DWORD        acc;

 err=XGetFileAttributes(name,&acc);

 if(err)
 {
  *type=0;
  err=NULL;
 }
 else
 {
  *type=(acc & FILE_ATTRIBUTE_DIRECTORY)?2:1;
 }

 return(err);
}

